﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.IO;
using System.Runtime.InteropServices;
using System.Text;
using System.Collections.ObjectModel;
using System.Threading;

namespace TrustedApp
{
    public partial class MainPage : UserControl
    {
        private ObservableCollection<NetInfo> netStat = new ObservableCollection<NetInfo>();
        private Timer timer = null;
        public MainPage()
        {
            InitializeComponent();

            StringBuilder computerName = new StringBuilder();
            Int32 nameLength = 256;
            if (WIN32API.GetComputerName(computerName, out nameLength))
            {
                lblInfo.Content = String.Format("计算机名称:{0}", computerName);
            }
            else
            {
                lblInfo.Content = "无法获取计算机名称!";
            }

            this.dg_list.ItemsSource = netStat;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            Button btn = sender as Button;
            if (btn.Tag.ToString() == "0")
            {
                btn.Tag = "1";
                btn.Content = "暂停";
                if (timer == null)
                {
                    timer = new Timer(new TimerCallback((obj) =>
                    {
                        this.Dispatcher.BeginInvoke(new Action(() =>
                        {
                            getNetStat();
                        }));
                    }), null, 1000, 1000);
                }
                else
                {
                    timer.Change(1000, 1000);
                }
            }
            else
            {
                btn.Tag = "0";
                btn.Content = "开始";
                if (timer != null)
                {
                    timer.Change(Timeout.Infinite, 1000);
                }
            }

            

            
        }

        private void getNetStat()
        {
            MIB_IFTABLE table = WIN32API.GetIfTable();

            List<NetInfo> delList = new List<NetInfo>();
            netStat.All(x =>
            {
                if (!table.table.Any(y => y.wszName == x.Name))
                {
                    delList.Add(x);
                }
                return true;
            });

            delList.All(x =>
            {
                netStat.Remove(x);
                return true;
            });

            foreach (MIB_IFROW row in table.table)
            {
                NetInfo oldRow = netStat.FirstOrDefault(x => x.Name == row.wszName);
                if (oldRow != null)
                {
                    int lastIn = oldRow.InOctets;
                    int lastOut = oldRow.OutOctets;

                    oldRow.CopyFromIFRow(row);
                    oldRow.InSpeed = oldRow.InOctets - lastIn;
                    oldRow.OutSpeed = oldRow.OutOctets - lastOut;
                }
                else
                {
                    netStat.Add(NetInfo.ConvertFromIFRow(row));
                }
            }

            
        }

    }
}
